// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property, executeInEditMode} = cc._decorator;

@ccclass
@executeInEditMode
export default class cus_progress extends cc.Component {
    _bg_size: cc.Size = cc.size(300, 30);
    @property({type: cc.Size, serializable: true})
    public get BG_SIZE() : cc.Size { return this._bg_size; }
    public set BG_SIZE(val: cc.Size) {
        this._bg_size = val;
        this.reSetNodeSize();
    }

    _bg_spriteframe: cc.SpriteFrame = new cc.SpriteFrame();
    @property({type: cc.SpriteFrame, serializable: true})
    public get BG_SPRITEFRAME() : cc.SpriteFrame { return this._bg_spriteframe; }
    public set BG_SPRITEFRAME(val: cc.SpriteFrame) {
        this._bg_spriteframe = val;
        this.bg_sprite.spriteFrame = this._bg_spriteframe;
        this.reSetNodeSize();
    }

    _bg_sprite_type: cc.Sprite.Type = cc.Sprite.Type.SLICED;
    @property({type: cc.Sprite.Type, serializable: true})
    public get BG_SPRITE_TYPE() : cc.Sprite.Type { return this._bg_sprite_type; }
    public set BG_SPRITE_TYPE(val: cc.Sprite.Type) {
        this._bg_sprite_type = val;
        this.bg_sprite.type = this._bg_sprite_type;
        this.reSetNodeSize();
    }

    _fg_size: cc.Size = cc.size(300, 30);
    @property({type: cc.Size, serializable: true})
    public get FG_SIZE() : cc.Size { return this._fg_size; }
    public set FG_SIZE(val: cc.Size) {
        this._fg_size = val;
        this.reSetNodeSize();
    }

    _fg_spriteframe: cc.SpriteFrame = new cc.SpriteFrame();
    @property({type: cc.SpriteFrame, serializable: true})
    public get FG_SPRITEFRAME() : cc.SpriteFrame { return this._fg_spriteframe; }
    public set FG_SPRITEFRAME(val: cc.SpriteFrame) {
        this._fg_spriteframe = val;
        this.fg_sprite.spriteFrame = this._fg_spriteframe;
        this.reSetNodeSize();
    }
    
    _fg_sprite_type: cc.Sprite.Type = cc.Sprite.Type.SLICED;
    @property({type: cc.Sprite.Type, serializable: true})
    public get FG_SPRITE_TYPE() : cc.Sprite.Type { return this._fg_sprite_type; }
    public set FG_SPRITE_TYPE(val: cc.Sprite.Type) {
        this._fg_sprite_type = val;
        this.fg_sprite.type = this._fg_sprite_type;
        this.reSetNodeSize();
    }

    _pr_slider: number = 50;
    @property({type: cc.Integer, slide: true, min: 0, max: 100, serializable: true})
    public get PR_SLIDER() : number { return this._pr_slider; }
    public set PR_SLIDER(val: number) {
        this._pr_slider = val;
        this.reSetNodeSize();
    }

    private reSetNodeSize() {
        this.bg_node.width = this._bg_size.width;
        this.bg_node.height = this._bg_size.height;

        this.mk_node.anchorX = 1.0;
        this.mk_node.width = this._fg_size.width * (1 - (this._pr_slider / 100));
        this.mk_node.height = this._fg_size.height;
        this.mk_node.x = this._fg_size.width / 2;
        
        this.fg_node.anchorX = 1.0;
        this.fg_node.width = this._fg_size.width;
        this.fg_node.height = this._fg_size.height;
        this.fg_node.x = 0;

        this.lb_label.string = `${this._pr_slider}%`;
    }
    
    _lb_isValid: boolean = false;
    @property({type: cc.Boolean, serializable: true})
    public get LB_isValid() : boolean { return this._lb_isValid; }
    public set LB_isValid(val: boolean) {
        this._lb_isValid = val;
        this.reSetLabel();
    }

    _lb_font: cc.Font = new cc.Font();
    @property({type: cc.Font, visible() { return this._lb_isValid == true; }, serializable: true})
    public get LB_FONT() : cc.Font { return this._lb_font; }
    public set LB_FONT(val: cc.Font) { this._lb_font = val; }
    
    _lb_size: number = 24;
    @property({type: cc.Integer, visible() { return this._lb_isValid == true; }, serializable: true})
    public get LB_SIZE() : number { return this._lb_size; }
    public set LB_SIZE(val: number) {
        this._lb_size = val;
        this.reSetLabel();
    }
    
    _lb_color: cc.Color = cc.color(255,255,255,255);
    @property({type: cc.Color, visible() { return this._lb_isValid == true; }, serializable: true})
    public get LB_COLOR() : cc.Color { return this._lb_color; }
    public set LB_COLOR(val: cc.Color) {
        this._lb_color = val;
        this.reSetLabel();
    }
    
    _lb_outline_isValid: boolean = false;
    @property({type: cc.Boolean, visible() { return this._lb_isValid == true; }, serializable: true})
    public get LB_OUTLINE_isValid() : boolean { return this._lb_outline_isValid; }
    public set LB_OUTLINE_isValid(val: boolean) {
        this._lb_outline_isValid = val;
        this.reSetLabel();
    }
    
    _lb_outline_size: number = 2;
    @property({type: cc.Integer, visible() { return this._lb_isValid == true && this._lb_outline_isValid == true; }, serializable: true})
    public get LB_OUTLINE_SIZE() : number { return this._lb_outline_size; }
    public set LB_OUTLINE_SIZE(val: number) {
        this._lb_outline_size = val;
        this.reSetLabel();
    }
    
    _lb_outline_color: cc.Color = cc.color(255,255,255,255);
    @property({type: cc.Color, visible() { return this._lb_isValid == true && this._lb_outline_isValid == true; }, serializable: true})
    public get LB_OUTLINE_COLOR() : cc.Color { return this._lb_outline_color; }
    public set LB_OUTLINE_COLOR(val: cc.Color) {
        this._lb_outline_color = val;
        this.reSetLabel();
    }

    private reSetLabel() {
        this.lb_node.active = this._lb_isValid;

        this.lb_node.anchorX = 1.0;
        this.lb_node.x = this._bg_size.width / 2;
        this.lb_node.color = this._lb_color;
        this.lb_label.font = this._lb_font;
        this.lb_label.fontSize = this._lb_size;
        this.lb_outlen.enabled = this._lb_outline_isValid;
        this.lb_outlen.color = this._lb_outline_color;
        this.lb_outlen.width = this._lb_outline_size; 
    }
    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    bg_node: cc.Node = null;
    bg_sprite: cc.Sprite = null;
    mk_node: cc.Node = null;
    mk_mask: cc.Mask = null;
    fg_node: cc.Node = null;
    fg_sprite: cc.Sprite = null;
    lb_node: cc.Node = null;
    lb_label: cc.Label = null;
    lb_outlen: cc.LabelOutline = null;

    __preload() {
        Editor.log('_reload')
        if (!this.node) {
            return;
        }

        this.node.removeAllChildren();

        if (!this.bg_node) {
            Editor.log('!this.bg_node')
            this.bg_node = new cc.Node();
            this.bg_node.name = 'bg_node';
            this.node.addChild(this.bg_node);

            this.bg_node.width = this._bg_size.width;
            this.bg_node.height = this._bg_size.height;

            this.bg_sprite = this.bg_node.addComponent(cc.Sprite);
            this.bg_sprite.type = this._bg_sprite_type;
            this.bg_sprite.spriteFrame = this._bg_spriteframe;
        }

        if (!this.mk_node) {
            Editor.log('!this.mk_node')
            this.mk_node = new cc.Node();
            this.mk_node.name = 'mk_node';

            this.mk_mask = this.mk_node.addComponent(cc.Mask);
            this.mk_mask.inverted = true;

            this.fg_node = new cc.Node();
            this.fg_node.name = 'fg_node';
            this.mk_node.addChild(this.fg_node);

            this.fg_node.width = this._fg_size.width;
            this.fg_node.height = this._fg_size.height;

            this.fg_sprite = this.fg_node.addComponent(cc.Sprite);
            this.fg_sprite.type = this._fg_sprite_type;
            this.fg_sprite.spriteFrame = this._fg_spriteframe;

            this.node.addChild(this.mk_node);
        }

        if (!this.lb_node) {
            Editor.log('!this.lb_node')
            this.lb_node = new cc.Node();
            this.lb_node.name = 'lb_node';
            this.node.addChild(this.lb_node);

            this.lb_label = this.lb_node.addComponent(cc.Label);
            this.lb_label.horizontalAlign = cc.Label.HorizontalAlign.CENTER;
            this.lb_label.verticalAlign = cc.Label.VerticalAlign.CENTER;
            this.lb_label.enableBold = true;

            this.lb_outlen = this.lb_node.addComponent(cc.LabelOutline);

            this.reSetLabel()
        }
        Editor.log('!this.lb_label', this.lb_label)
    }

    start () {

    }

    // update (dt) {}
}




// property(
//     options ?: { 
//         type?: any; 
//         visible?: boolean | (() => boolean); 
//         displayName?: string; 
//         tooltip?: string; 
//         multiline?: boolean; 
//         readonly?: boolean; 
//         min?: number; 
//         max?: number; 
//         step?: number; 
//         range?: number[]; 
//         slide?: boolean; 
//         serializable?: boolean; 
//         formerlySerializedAs?: string; 
//         editorOnly?: boolean; 
//         override?: boolean; 
//         animatable?: boolean 
//     } | any[] | Function | cc.ValueType | number | string | boolean): Function;